import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import javax.swing.text.*;
import java.util.*;
import java.awt.image.*;
import java.net.*;
import javax.imageio.*;

public class ImageAsyncObserverExample implements Runnable {
  private class MyPanel extends JPanel {
    private Image image;
    private boolean onLoad;
    private int percent, height;
    public MyPanel() {
      try {
        URL url = new URL("http://www.liafa.univ-paris-diderot.fr/~yunes/images/TEST/DiplomeCodeOrg.jpg");
        image = Toolkit.getDefaultToolkit().getImage(url); // asynchronous loading
        image = image.getScaledInstance(500,300,Image.SCALE_DEFAULT); // scale it down..
        setPreferredSize(new Dimension(500,300));
      } catch(Exception e) {
        e.printStackTrace();
      }
      onLoad = true;
      percent = 0;
      height = 0;
    }
    public void paintComponent(Graphics g) {
      g.clearRect(0,0,500,300);
      g.drawImage(image,0,0,this);
      if (onLoad) g.drawString("ON LOAD "+percent+"%",100,100);
    }
    public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height) {
      if ((infoflags&(HEIGHT))!=0) {
        this.height = height;
      }
      if ((infoflags&(ALLBITS|ERROR|ABORT))!=0) {
        onLoad = (infoflags&ALLBITS)==0;
        repaint(); // one last paint
        return false;
      }
      if (this.height!=0) percent = (int)(y*100.0/this.height);
      repaint(); // animate %
      return true;
    }
  }
  public static void main(String [] args) {
    SwingUtilities.invokeLater(new ImageAsyncObserverExample());
  }
  public void run() {
    JFrame f = new JFrame(this.getClass().getName());
    Container c = f.getContentPane();
    MyPanel p = new MyPanel();
    c.add(p);
    f.pack();
    f.setVisible(true);
  }
}
