import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.util.concurrent.*;
import java.util.List;

class LongJob extends SwingWorker<Void,Integer> {
    private JProgressBar pb;
    public LongJob(JProgressBar pb) { this.pb = pb; }
    // This is the task to be done in background...
    public Void doInBackground() {
	Random r = new Random();
	for (int i=0; i<=100; i++) {
	    try {
		Thread.sleep(100+r.nextInt(200));
		// Feed the GUI !
		publish(i);
	    } catch(InterruptedException e) {
	    }
	}
	return null;
    }

    // This is what has to be done under GUI's thread control...
    public void process(List<Integer> l) {
	for (int i : l) {
	    if (i==0) pb.setIndeterminate(false);
	    pb.setValue(i);
	}
    }

    // RIP 'Lizard King', 7/3/71
    // This is the end, my only friend, the end, no safety or surprise, the end
    public void done() {
	pb.setVisible(false);
        //	firePropertyChange("done",false,true);
    }
}

class DoIt implements ActionListener {
    LongJob lj;
    public DoIt(JProgressBar pb) { lj = new LongJob(pb); }
    public void actionPerformed(ActionEvent e) {
	if (!lj.isDone()) {
	    lj.execute();
	}
    }
    public LongJob getJob() { return lj; }
}

public class ProgressBarExample implements Runnable {
    static private LongJob lj;
    public void run() {
	JFrame f = new JFrame("ProgressBarExample");
	Container c = f.getContentPane();
	c.setLayout(new BoxLayout(c,BoxLayout.Y_AXIS));
	JProgressBar pb = new JProgressBar(SwingConstants.HORIZONTAL,0,100);
	pb.setValue(0);
	pb.setStringPainted(true);
	pb.setIndeterminate(true);
	c.add(pb);
	JButton b = new JButton("Allez!");
	c.add(b);
	DoIt doit = new DoIt(pb);
	b.addActionListener(doit);
	f.pack();
	f.setVisible(true);

	lj = doit.getJob();
    }
    public static void main(String [] args) {
	try {
	    SwingUtilities.invokeAndWait(new ProgressBarExample());
	} catch (Exception e) {
	    e.printStackTrace();
	    System.exit(1);
	}
	try {
          System.out.println("Waitin in vain...");
	    // 'til can get enough...
	    lj.get();
          System.out.println("Ya!");

	} catch(Exception e) {
	}
	System.out.println("ici");
    }
}
